diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/test/tx-duration-test.cc ns-3.46/src/wifi/test/tx-duration-test.cc
--- ns-3.45/src/wifi/test/tx-duration-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/test/tx-duration-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -2235,8 +2235,7 @@
      * @param obtained the map of PHY header sections to check
      * @param expected the expected map of PHY header sections
      */
-    void CheckPhyHeaderSections(PhyEntity::PhyHeaderSections obtained,
-                                PhyEntity::PhyHeaderSections expected);
+    void CheckPhyHeaderSections(PhyHeaderSections obtained, PhyHeaderSections expected);
 };
 
 PhyHeaderSectionsTest::PhyHeaderSectionsTest()
@@ -2249,8 +2248,8 @@
 }
 
 void
-PhyHeaderSectionsTest::CheckPhyHeaderSections(PhyEntity::PhyHeaderSections obtained,
-                                              PhyEntity::PhyHeaderSections expected)
+PhyHeaderSectionsTest::CheckPhyHeaderSections(PhyHeaderSections obtained,
+                                              PhyHeaderSections expected)
 {
     NS_ASSERT_MSG(obtained.size() == expected.size(),
                   "The expected map size (" << expected.size() << ") was not obtained ("
@@ -2295,14 +2294,14 @@
 PhyHeaderSectionsTest::DoRun()
 {
     Time ppduStart = Seconds(1);
-    Ptr<PhyEntity> phyEntity;
-    PhyEntity::PhyHeaderSections sections;
+    std::shared_ptr<PhyEntity> phyEntity;
+    PhyHeaderSections sections;
     WifiTxVector txVector;
     WifiMode nonHtMode;
 
     // ==================================================================================
     // 11b (HR/DSSS)
-    phyEntity = Create<DsssPhy>();
+    phyEntity = std::make_shared<DsssPhy>();
     txVector.SetMode(DsssPhy::GetDsssRate1Mbps());
     txVector.SetChannelWidth(MHz_u{22});
 
@@ -2344,7 +2343,7 @@
     };
     for (auto variant : variants)
     {
-        phyEntity = Create<OfdmPhy>(variant.first);
+        phyEntity = std::make_shared<OfdmPhy>(variant.first);
         std::size_t ratio = variant.second;
         const auto bw = MHz_u{20} / ratio;
         txVector.SetChannelWidth(bw);
@@ -2362,7 +2361,7 @@
 
     // ==================================================================================
     // 11g (ERP-OFDM)
-    phyEntity = Create<ErpOfdmPhy>();
+    phyEntity = std::make_shared<ErpOfdmPhy>();
     txVector.SetChannelWidth(MHz_u{20});
     txVector.SetMode(ErpOfdmPhy::GetErpOfdmRate(54000000));
     nonHtMode = ErpOfdmPhy::GetErpOfdmRate6Mbps();
@@ -2375,7 +2374,7 @@
 
     // ==================================================================================
     // 11n (HT)
-    phyEntity = Create<HtPhy>(4);
+    phyEntity = std::make_shared<HtPhy>(4);
     txVector.SetChannelWidth(MHz_u{20});
     txVector.SetMode(HtPhy::GetHtMcs6());
     nonHtMode = OfdmPhy::GetOfdmRate6Mbps();
@@ -2410,7 +2409,7 @@
 
     // ==================================================================================
     // 11ac (VHT)
-    phyEntity = Create<VhtPhy>();
+    phyEntity = std::make_shared<VhtPhy>();
     txVector.SetChannelWidth(MHz_u{20});
     txVector.SetNess(0);
     txVector.SetMode(VhtPhy::GetVhtMcs7());
@@ -2453,7 +2452,7 @@
 
     // ==================================================================================
     // 11ax (HE)
-    phyEntity = Create<HePhy>();
+    phyEntity = std::make_shared<HePhy>();
     txVector.SetChannelWidth(MHz_u{20});
     txVector.SetNss(2); // HE-LTF duration assumed to be always 8 us for the time being (see note in
                         // HePhy::GetTrainingDuration)
@@ -2526,7 +2525,7 @@
     // 11be (EHT)
     sections.erase(WIFI_PPDU_FIELD_SIG_A); // FIXME: do we keep using separate type for 11be?
     sections.erase(WIFI_PPDU_FIELD_SIG_B); // FIXME: do we keep using separate type for 11be?
-    phyEntity = Create<EhtPhy>();
+    phyEntity = std::make_shared<EhtPhy>();
     txVector.SetChannelWidth(MHz_u{20});
     txVector.SetNss(2); // EHT-LTF duration assumed to be always 8 us for the time being (see note
                         // in HePhy::GetTrainingDuration)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/test/wifi-channel-switching-test.cc ns-3.46/src/wifi/test/wifi-channel-switching-test.cc
--- ns-3.45/src/wifi/test/wifi-channel-switching-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/test/wifi-channel-switching-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -209,8 +209,6 @@
 void
 WifiChannelSwitchingTest::DoRun()
 {
-    Time simulationTime(Seconds(6));
-
     RngSeedManager::SetSeed(1);
     RngSeedManager::SetRun(40);
     int64_t streamNumber = 100;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/test/wifi-dynamic-bw-op-test.cc ns-3.46/src/wifi/test/wifi-dynamic-bw-op-test.cc
--- ns-3.45/src/wifi/test/wifi-dynamic-bw-op-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/test/wifi-dynamic-bw-op-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -155,8 +155,8 @@
         client->SetAttribute("Interval", TimeValue(MicroSeconds(0)));
         client->SetRemote(m_sockets[0]);
         m_apDevices.Get(0)->GetNode()->AddApplication(client);
-        client->SetStartTime(Seconds(0)); // start now
-        client->SetStopTime(Seconds(1));  // stop in a second
+        client->SetStartTime(TimeStep(1)); // start shortly after the start of PPDU in BSS 1
+        client->SetStopTime(Seconds(1));   // stop in a second
         client->Initialize();
 
         // after 1us (to allow for propagation delay), the largest idle primary
@@ -470,20 +470,18 @@
     AddTestCase(
         new WifiUseAvailBwTest({"{50, 160, BAND_5GHZ, 5}", "{42, 80, BAND_5GHZ, 2}"}, MHz_u{80}),
         TestCase::Duration::QUICK);
-    // clang-format off
     /**
-     *                                                                                 ───────────────────────────── primary 160 ─────────────────────────────
-     *                                                                                                    primary20
-     *          ┌────────┬────────┬────────┬────────┬───────┬────────┬────────┬────────┌────────┬────────┬────────┬────────┬───────┬────────┬────────┬────────┐
-     *  BSS 0   │   1    │   5    │   9    │   13   │  17   │   21   │   25   │   29   │   33   │   37   │   41   │   45   │  49   │   53   │   57   │   61   │
-     *          └────────┴────────┴────────┴────────┴───────┴────────┴────────┴────────└────────┴────────┴────────┴────────┴───────┴────────┴────────┴────────┘
+     *                                                  ────────────── primary 160 ──────────────
+     *                                                           primary20
+     *          ┌────┬────┬────┬────┬────┬────┬────┬────┬────┬────┬────┬────┬────┬────┬────┬────┐
+     *  BSS 0   │  1 │  5 │  9 │ 13 │ 17 │ 21 │ 25 │ 29 │ 33 │ 37 │ 41 │ 45 │ 49 │ 53 │ 57 │ 61 │
+     *          └────┴────┴────┴────┴────┴────┴────┴────┴────┴────┴────┴────┴────┴────┴────┴────┘
      *
-     *          ┌────────┬────────┬────────┬────────┬───────┬────────┬────────┬────────┐
-     *  BSS 1   │   1    │   5    │   9    │   13   │  17   │   21   │   25   │   29   │
-     *          └────────┴────────┴────────┴────────┴───────┴────────┴────────┴────────┘
-     *                                                                         primary20
+     *          ┌────┬────┬────┬────┬────┬────┬────┬────┐
+     *  BSS 1   │  1 │  5 │  9 │ 13 │ 17 │ 21 │ 25 │ 29 │
+     *          └────┴────┴────┴────┴────┴────┴────┴────┘
+     *                                            primary20
      */
-    // clang-format on
     AddTestCase(
         new WifiUseAvailBwTest({"{31, 320, BAND_6GHZ, 10}", "{15, 160, BAND_6GHZ, 7}"}, 160),
         TestCase::Duration::QUICK);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/test/wifi-eht-info-elems-test.cc ns-3.46/src/wifi/test/wifi-eht-info-elems-test.cc
--- ns-3.45/src/wifi/test/wifi-eht-info-elems-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/test/wifi-eht-info-elems-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -635,7 +635,7 @@
 
     std::stringstream info;
 
-    if (channel2_4It != WifiPhyOperatingChannel::m_frequencyChannels.cend())
+    if (channel2_4It != WifiPhyOperatingChannel::GetFrequencyChannels().cend())
     {
         WifiPhyOperatingChannel channel(channel2_4It);
 
@@ -652,7 +652,7 @@
         rnr.SetMldParameters(nbrId, 0, {0, 2, 3, 1, 1});
     }
 
-    if (channel5It != WifiPhyOperatingChannel::m_frequencyChannels.cend())
+    if (channel5It != WifiPhyOperatingChannel::GetFrequencyChannels().cend())
     {
         WifiPhyOperatingChannel channel(channel5It);
 
@@ -676,7 +676,7 @@
         rnr.SetMldParameters(nbrId, 1, {0, 4, 5, 1, 0});
     }
 
-    if (channel6It != WifiPhyOperatingChannel::m_frequencyChannels.cend())
+    if (channel6It != WifiPhyOperatingChannel::GetFrequencyChannels().cend())
     {
         WifiPhyOperatingChannel channel(channel6It);
 
@@ -703,14 +703,15 @@
     PhyOpChannelIt channel2_4It;
     PhyOpChannelIt channel5It;
     PhyOpChannelIt channel6It;
-    channel2_4It = channel5It = channel6It = WifiPhyOperatingChannel::m_frequencyChannels.cbegin();
+    channel2_4It = channel5It = channel6It =
+        WifiPhyOperatingChannel::GetFrequencyChannels().cbegin();
 
     // Test all available frequency channels
-    while (channel2_4It != WifiPhyOperatingChannel::m_frequencyChannels.cend() ||
-           channel5It != WifiPhyOperatingChannel::m_frequencyChannels.cend() ||
-           channel6It != WifiPhyOperatingChannel::m_frequencyChannels.cend())
+    while (channel2_4It != WifiPhyOperatingChannel::GetFrequencyChannels().cend() ||
+           channel5It != WifiPhyOperatingChannel::GetFrequencyChannels().cend() ||
+           channel6It != WifiPhyOperatingChannel::GetFrequencyChannels().cend())
     {
-        if (channel2_4It != WifiPhyOperatingChannel::m_frequencyChannels.cend())
+        if (channel2_4It != WifiPhyOperatingChannel::GetFrequencyChannels().cend())
         {
             channel2_4It = WifiPhyOperatingChannel::FindFirst(0,
                                                               MHz_u{0},
@@ -719,7 +720,7 @@
                                                               WIFI_PHY_BAND_2_4GHZ,
                                                               channel2_4It);
         }
-        if (channel5It != WifiPhyOperatingChannel::m_frequencyChannels.cend())
+        if (channel5It != WifiPhyOperatingChannel::GetFrequencyChannels().cend())
         {
             channel5It = WifiPhyOperatingChannel::FindFirst(0,
                                                             MHz_u{0},
@@ -728,7 +729,7 @@
                                                             WIFI_PHY_BAND_5GHZ,
                                                             channel5It);
         }
-        if (channel6It != WifiPhyOperatingChannel::m_frequencyChannels.cend())
+        if (channel6It != WifiPhyOperatingChannel::GetFrequencyChannels().cend())
         {
             channel6It = WifiPhyOperatingChannel::FindFirst(0,
                                                             MHz_u{0},
@@ -741,15 +742,15 @@
         TestHeaderSerialization(GetReducedNeighborReport(channel2_4It, channel5It, channel6It));
 
         // advance all channel iterators
-        if (channel2_4It != WifiPhyOperatingChannel::m_frequencyChannels.cend())
+        if (channel2_4It != WifiPhyOperatingChannel::GetFrequencyChannels().cend())
         {
             channel2_4It++;
         }
-        if (channel5It != WifiPhyOperatingChannel::m_frequencyChannels.cend())
+        if (channel5It != WifiPhyOperatingChannel::GetFrequencyChannels().cend())
         {
             channel5It++;
         }
-        if (channel6It != WifiPhyOperatingChannel::m_frequencyChannels.cend())
+        if (channel6It != WifiPhyOperatingChannel::GetFrequencyChannels().cend())
         {
             channel6It++;
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/test/wifi-emlsr-basic-exchanges-test.cc ns-3.46/src/wifi/test/wifi-emlsr-basic-exchanges-test.cc
--- ns-3.45/src/wifi/test/wifi-emlsr-basic-exchanges-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/test/wifi-emlsr-basic-exchanges-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -151,8 +151,6 @@
 {
     // Channel switch delay should be less than the ICF padding duration, otherwise
     // DL TXOPs cannot be initiated on auxiliary links
-    auto delay = std::min(MicroSeconds(100),
-                          *std::min_element(m_paddingDelay.cbegin(), m_paddingDelay.cend()));
     Config::SetDefault("ns3::WifiPhy::ChannelSwitchDelay", TimeValue(MicroSeconds(75)));
 
     EmlsrOperationsTestBase::DoSetup();
@@ -778,7 +776,6 @@
         bAckRespTxEnd = bAckRespIt->startTx + WifiPhy::CalculateTxDuration(bAckRespIt->psduMap,
                                                                            bAckRespIt->txVector,
                                                                            phy->GetPhyBand());
-        auto timeout = phy->GetSifs() + phy->GetSlot() + MicroSeconds(20);
 
         // the fourth frame exchange starts a PIFS after the previous one because the AP
         // performs PIFS recovery (the initial frame in the TXOP was successfully received by
@@ -2593,6 +2590,16 @@
                           "RTS before second data frame transmitted on an unexpected width");
     psduIt++;
     // CTS
+    if (m_nonEmlsrLink && psduIt != m_txPsdus.cend() &&
+        psduIt->psduMap.cbegin()->second->GetHeader(0).IsBlockAck())
+    {
+        // in case a non-EMLSR link is present, the QoS data frame (seq. numbers 6 and 7) may be
+        // sent late on that link due to the ongoing backoff, thus the corresponding BlockAck is
+        // transmitted on that link after the RTS but before the CTS transmitted on the other EMLSR
+        // aux link
+        ++psduIt;
+    }
+
     NS_TEST_ASSERT_MSG_EQ((psduIt != m_txPsdus.cend()),
                           true,
                           "CTS before second QoS data frame has not been transmitted");
@@ -2714,9 +2721,12 @@
                           "Fourth data frame not transmitted on the same width as RTS");
 }
 
-EmlsrUlOfdmaTest::EmlsrUlOfdmaTest(bool enableBsrp)
-    : EmlsrOperationsTestBase("Check UL OFDMA operations with an EMLSR client"),
+EmlsrUlOfdmaTest::EmlsrUlOfdmaTest(bool enableBsrp, bool protectSingleExchange)
+    : EmlsrOperationsTestBase("Check UL OFDMA operations with an EMLSR client (enableBsrp=" +
+                              std::to_string(enableBsrp) + ", protectSingleExchange=" +
+                              std::to_string(protectSingleExchange) + ")"),
       m_enableBsrp(enableBsrp),
+      m_protectSingleExchange(protectSingleExchange),
       m_txPsdusPos(0),
       m_startAccessReq(0)
 {
@@ -2733,6 +2743,11 @@
 EmlsrUlOfdmaTest::DoSetup()
 {
     Config::SetDefault("ns3::WifiPhy::ChannelSwitchDelay", TimeValue(m_transitionDelay.at(0)));
+    Config::SetDefault("ns3::QosFrameExchangeManager::ProtectSingleExchange",
+                       BooleanValue(m_protectSingleExchange));
+    Config::SetDefault("ns3::DefaultEmlsrManager::SwitchAuxPhy", BooleanValue(false));
+    Config::SetDefault("ns3::EhtFrameExchangeManager::EarlyTxopEndDetect",
+                       BooleanValue(!(m_enableBsrp && m_protectSingleExchange)));
 
     EmlsrOperationsTestBase::DoSetup();
 
@@ -2765,6 +2780,7 @@
         {
             // this is the first Trigger Frame sent after the AP requested channel access
             // through the Multi-user scheduler and it is an ICF for the EMLSR client
+            m_1stTfLinkId = linkId;
             m_txPsdusPos = m_txPsdus.size() - 1;
             auto txDuration = WifiPhy::CalculateTxDuration(psduMap,
                                                            txVector,
@@ -2795,6 +2811,37 @@
         }
         break;
 
+    case WIFI_MAC_QOSDATA_NULL:
+        if (linkId == m_1stTfLinkId &&
+            psdu->GetAddr2() == m_staMacs[0]->GetFrameExchangeManager(linkId)->GetAddress())
+        {
+            NS_TEST_EXPECT_MSG_EQ(m_enableBsrp,
+                                  true,
+                                  "EMLSR client is not expected to send a QoS null on the same "
+                                  "link as the first TF when BSRP is disabled");
+
+            // the Duration/ID of the QoS null frame sent by the EMLSR client after the first
+            // Trigger Frame on the same link is zero if and only if ProtectSingleExchange is true
+            NS_TEST_EXPECT_MSG_EQ(psdu->GetDuration().IsZero(),
+                                  m_protectSingleExchange,
+                                  "Unexpected Duration/ID (" << psdu->GetDuration()
+                                                             << ") when ProtectSingleExchange="
+                                                             << m_protectSingleExchange);
+
+            const auto txDuration =
+                WifiPhy::CalculateTxDuration(psduMap,
+                                             txVector,
+                                             mac->GetWifiPhy(linkId)->GetPhyBand());
+            Simulator::Schedule(txDuration + MAX_PROPAGATION_DELAY, [=, this]() {
+                auto ehtFem = StaticCast<EhtFrameExchangeManager>(
+                    m_staMacs[0]->GetFrameExchangeManager(linkId));
+                NS_TEST_EXPECT_MSG_EQ(ehtFem->GetOngoingTxopEndEvent().IsPending(),
+                                      true,
+                                      "After QoS Null frame, the TXOP is not expected to be ended");
+            });
+        }
+        break;
+
     case WIFI_MAC_CTL_BACKRESP:
         if (!m_startAccessReq.IsZero() && Simulator::Now() >= m_startAccessReq)
         {
@@ -3083,8 +3130,14 @@
                     TestCase::Duration::QUICK);
     }
 
-    AddTestCase(new EmlsrUlOfdmaTest(false), TestCase::Duration::QUICK);
-    AddTestCase(new EmlsrUlOfdmaTest(true), TestCase::Duration::QUICK);
+    for (const auto enableBsrp : {true, false})
+    {
+        for (const auto protectSingleExchange : {true, false})
+        {
+            AddTestCase(new EmlsrUlOfdmaTest(enableBsrp, protectSingleExchange),
+                        TestCase::Duration::QUICK);
+        }
+    }
 }
 
 static WifiEmlsrBasicExchangesTestSuite g_wifiEmlsrBasicExchangesTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/test/wifi-emlsr-basic-exchanges-test.h ns-3.46/src/wifi/test/wifi-emlsr-basic-exchanges-test.h
--- ns-3.45/src/wifi/test/wifi-emlsr-basic-exchanges-test.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/test/wifi-emlsr-basic-exchanges-test.h	2025-10-01 18:46:32.000000000 -0700
@@ -392,6 +392,12 @@
  *   (AP MLD has blocked transmissions to the EMLSR client upon preparing the first Trigger Frame)
  * - the buffer status reported in QoS Null frames is as expected
  * - the EMLSR client sends a QoS Data frame in a TB PPDU
+ *
+ * It is also checked that, when sending BSRP TF is enabled and the single protection mechanism is
+ * used, the QoS Null frames sent in response to the BSRP TF acting as ICF have a Duration/ID of
+ * zero but the EMLSR client does not consider the TXOP ended when the transmission of the QoS Null
+ * frame ends (because in this case the ns3::EhtFrameExchangeManager::EarlyTxopEndDetect attribute
+ * is set to false) and therefore correctly receives the Basic Trigger Frame sent after a SIFS.
  */
 class EmlsrUlOfdmaTest : public EmlsrOperationsTestBase
 {
@@ -400,8 +406,9 @@
      * Constructor
      *
      * @param enableBsrp whether MU scheduler sends BSRP TFs
+     * @param protectSingleExchange whether single protection mechanism is used
      */
-    EmlsrUlOfdmaTest(bool enableBsrp);
+    EmlsrUlOfdmaTest(bool enableBsrp, bool protectSingleExchange);
 
   protected:
     void DoSetup() override;
@@ -420,9 +427,11 @@
   private:
     void StartTraffic() override;
 
-    bool m_enableBsrp;        //!< whether MU scheduler sends BSRP TFs
-    std::size_t m_txPsdusPos; //!< position in the vector of TX PSDUs of the first ICF
-    Time m_startAccessReq;    //!< start time of the first AP MLD access request via MU scheduler
+    bool m_enableBsrp;            //!< whether MU scheduler sends BSRP TFs
+    bool m_protectSingleExchange; //!< whether single protection mechanism is used
+    std::size_t m_txPsdusPos;     //!< position in the vector of TX PSDUs of the first ICF
+    Time m_startAccessReq; //!< start time of the first AP MLD access request via MU scheduler
+    std::optional<uint8_t> m_1stTfLinkId; //!< ID of the link on which the first TF is sent
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/test/wifi-emlsr-link-switch-test.cc ns-3.46/src/wifi/test/wifi-emlsr-link-switch-test.cc
--- ns-3.45/src/wifi/test/wifi-emlsr-link-switch-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/test/wifi-emlsr-link-switch-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -1677,18 +1677,20 @@
             m_staMacs[0]->GetDevice()->GetNode()->AddApplication(
                 GetApplication(UPLINK, 0, 1, 500, 4));
             // channel access can be obtained within a slot due to slot alignment
-            Simulator::Schedule(m_apMac->GetWifiPhy(m_linkIdForTid4)->GetSlot(), [=, this]() {
-                auto advEmlsrMgr =
-                    DynamicCast<AdvancedEmlsrManager>(m_staMacs[0]->GetEmlsrManager());
+            Simulator::Schedule(
+                m_apMac->GetWifiPhy(m_linkIdForTid4)->GetSlot() + TimeStep(1),
+                [=, this]() {
+                    auto advEmlsrMgr =
+                        DynamicCast<AdvancedEmlsrManager>(m_staMacs[0]->GetEmlsrManager());
 
-                NS_TEST_EXPECT_MSG_EQ(advEmlsrMgr->m_mainPhySwitchInfo.disconnected,
-                                      true,
-                                      "Expected the main PHY to be switching");
-                NS_TEST_EXPECT_MSG_EQ(
-                    +advEmlsrMgr->m_mainPhySwitchInfo.to,
-                    +(advEmlsrMgr->m_interruptSwitching ? m_linkIdForTid4 : m_mainPhyId),
-                    "Main PHY is switching to wrong link");
-            });
+                    NS_TEST_EXPECT_MSG_EQ(advEmlsrMgr->m_mainPhySwitchInfo.disconnected,
+                                          true,
+                                          "Expected the main PHY to be switching");
+                    NS_TEST_EXPECT_MSG_EQ(
+                        +advEmlsrMgr->m_mainPhySwitchInfo.to,
+                        +(advEmlsrMgr->m_interruptSwitching ? m_linkIdForTid4 : m_mainPhyId),
+                        "Test index " << +m_testIndex << ": Main PHY is switching to wrong link");
+                });
         });
         InsertEventsForQosTid4();
     };
@@ -2193,7 +2195,6 @@
     m_events.emplace_back(
         WIFI_MAC_CTL_ACK,
         [=, this](Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector, uint8_t linkId) {
-            const auto phyHdrDuration = WifiPhy::CalculatePhyPreambleAndHeaderDuration(txVector);
             const auto txDuration =
                 WifiPhy::CalculateTxDuration(psdu,
                                              txVector,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/test/wifi-emlsr-test-base.cc ns-3.46/src/wifi/test/wifi-emlsr-test-base.cc
--- ns-3.45/src/wifi/test/wifi-emlsr-test-base.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/test/wifi-emlsr-test-base.cc	2025-10-01 18:46:32.000000000 -0700
@@ -626,7 +626,7 @@
                                           std::string description,
                                           bool testUnblockedForOtherReasons)
 {
-    WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE, WIFI_UNICAST, dest, 0);
+    WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE, WifiRcvAddr::UNICAST, dest, 0);
     auto mask = mac->GetMacQueueScheduler()->GetQueueLinkMask(AC_BE, queueId, linkId);
     NS_TEST_EXPECT_MSG_EQ(mask.has_value(),
                           true,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/test/wifi-fils-frame-test.cc ns-3.46/src/wifi/test/wifi-fils-frame-test.cc
--- ns-3.45/src/wifi/test/wifi-fils-frame-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/test/wifi-fils-frame-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -177,10 +177,7 @@
     MobilityHelper mobility;
     node.Create(1);
     phy.SetChannel(channel);
-    AttributeContainerValue<
-        TupleValue<UintegerValue, UintegerValue, EnumValue<WifiPhyBand>, UintegerValue>,
-        ';'>
-        channelValue;
+    WifiPhy::ChannelSettingsValue channelValue;
     channelValue.Set(WifiPhy::ChannelSegments{
         {INVALID_CHAN_NUM, m_params.bw, DEFAULT_BAND, DEFAULT_PRIMARY_INDEX}});
     phy.Set("ChannelSettings", channelValue);
